import { useContext, useEffect, useState } from "react";
import LogContext from "../../state/Supabase";
import LineChart from "./charts/LineChart";

const Chart = () => {
  const { speedLog, batteryLog } = useContext(LogContext);

  const [chartData, setChartData] = useState({
    labels: speedLog.map((data) => data.time),
    datasets: [
      {
        label: "Speed (%) ",
        data: speedLog.map((data) => data.speed),
        backgroundColor: "white",
        borderColor: "white",
        borderWidth: 2,
      },
    ],
  });

  useEffect(() => {
    setChartData({
      labels: ["", "", "", "", "", "", "", "", "", ""],
      datasets: [
        {
          label: "Speed (%) ",
          data: speedLog
            .slice(1)
            .slice(-10)
            .map((data) => data.speed),
          backgroundColor: "rgba(0, 98, 255,0.3)",
          borderColor: "rgba(0, 98, 255,0.8)",
          borderWidth: 2,
          showLine: true,
          fill: true,
          tension: 0.3,
        },
        {
          label: "Battery (%) ",
          data: batteryLog
            .slice(1)
            .slice(-10)
            .map((data) => data.percentage),
          backgroundColor: "rgba(0, 200, 255,0.3)",
          borderColor: "rgba(0, 200, 255,0.8)",
          borderWidth: 2,
          showLine: true,
          fill: true,
          tension: 0.3,
        },
      ],
    });
  }, [speedLog]);

  return <LineChart chartData={chartData} />;
};

export default Chart;
