import { Typography } from "antd";
import { forwardRef, useEffect, useState } from "react";

const InventoryBox = forwardRef((props, ref: any) => {
  const [storage, setStorage] = useState<any[]>([]);

  useEffect(() => {
    const interval = setInterval(() => {
      if (!ref) return;
      if (ref.current.robot.storage !== storage)
        setStorage(ref.current.robot.storage);
    }, 1000);

    return () => clearInterval(interval);
  }, [ref, storage]);
  return (
    <div
      style={{
        width: "44%",
        height: 400,
        background:
          "linear-gradient(300deg, rgba(40,40,40,0.8) 0%, rgba(0,0,0,0.8) 100%)",
        borderRadius: 15,
        display: "flex",
        alignItems: "flex-start",
        padding: 15,
        flexDirection: "column",
      }}
    >
      <div
        style={{
          display: "flex",
          justifyContent: "center",
          alignItems: "center",
          width: "100%",
          height: "70%",
          color: "white",
        }}
      >
        NO DATA
      </div>
      <Typography.Text
        strong
        style={{ color: "white", margin: 0, fontSize: 28 }}
      >
        Inventory
      </Typography.Text>
      <Typography.Text
        strong
        style={{
          color: "gray",
          fontSize: 14,
        }}
      >
        {storage.length} items stored
      </Typography.Text>
    </div>
  );
});

export default InventoryBox;
