import { Progress, Space, Typography } from "antd";
import { useContext } from "react";
import RobotContext from "../../state/Robot";

//This component shows the speed of the rover
const WheelSpeedBox = () => {
  const { Lpower, Rpower } = useContext(RobotContext);

  return (
    <div
      style={{
        width: "30%",
        height: 350,
        background:
          "linear-gradient(300deg, rgba(40,40,40,0.8) 0%, rgba(0,0,0,0.8) 100%)",
        borderRadius: 15,
        display: "flex",
        alignItems: "flex-start",
        padding: 15,
        flexDirection: "column",
      }}
    >
      <div>
        <div style={{ display: "flex", flexDirection: "column" }}>
          <Typography.Text
            strong
            style={{ color: "white", margin: 0, fontSize: 24 }}
          >
            Speed
          </Typography.Text>
        </div>
      </div>
      <div
        style={{
          display: "flex",
          justifyContent: "space-between",
          width: "100%",
        }}
      >
        <div
          style={{
            marginTop: 50,
            display: "flex",
            justifyContent: "center",
            alignItems: "center",
            width: "100%",
            flexDirection: "column",
          }}
        >
          <Space direction="vertical">
            <div
              style={{
                width: "200px",
                padding: "10px 20px 10px 20px",
                background:
                  "linear-gradient(300deg, rgba(40,40,40,0.8) 0%, rgba(0,0,0,0.8) 100%)",
                borderRadius: 15,
                display: "flex",
                flexDirection: "column",
                alignItems: "flex-start",
                justifyContent: "flex-start",
              }}
            >
              <Typography.Text
                strong
                style={{
                  color: "gray",
                  margin: "0px 0px -5px 0px",
                  fontSize: 12,
                }}
              >
                Right wheel
              </Typography.Text>
              <Typography.Text
                strong
                style={{
                  color: "white",
                  margin: "0px 0px 0px 0px",
                  fontSize: 24,
                }}
              >
                {Rpower * 100}%
              </Typography.Text>
            </div>
            <div
              style={{
                width: "200px",
                padding: "10px 20px 10px 20px",
                background:
                  "linear-gradient(300deg, rgba(40,40,40,0.8) 0%, rgba(0,0,0,0.8) 100%)",
                borderRadius: 15,
                display: "flex",
                flexDirection: "column",
                alignItems: "flex-start",
                justifyContent: "flex-start",
              }}
            >
              <Typography.Text
                strong
                style={{
                  color: "gray",
                  margin: "0px 0px -5px 0px",
                  fontSize: 12,
                }}
              >
                Left wheel
              </Typography.Text>
              <Typography.Text
                strong
                style={{
                  color: "white",
                  margin: "0px 0px 0px 0px",
                  fontSize: 24,
                }}
              >
                {Lpower * 100}%
              </Typography.Text>
            </div>
          </Space>
        </div>
        <div
          style={{
            marginTop: 50,
            display: "flex",
            justifyContent: "center",
            alignItems: "center",
            width: "100%",
            flexDirection: "column",
          }}
        >
          <Progress
            size="default"
            type="dashboard"
            percent={((Lpower + Rpower) / 2) * 100}
            strokeColor={{ "0%": "#0080ff", "100%": "#094185" }}
          />
          <Typography.Text
            strong
            style={{
              color: "gray",
              margin: "0px 0px -10px 0px",
              fontSize: 12,
            }}
          >
            Total speed
          </Typography.Text>
        </div>
      </div>
    </div>
  );
};

export default WheelSpeedBox;
