import PlaneSquare from "../map/components/objects/plane/components/PlaneSquare";
import { Vector3, Vector2, Euler } from "three";
import { Position2 } from "../models/Data";

export const generateInteractionPlane = (
  width: number,
  height: number,
  setHoveredCoordinate: (position: Position2) => void
): JSX.Element[] => {
  let planes = [] as JSX.Element[];

  let counter = 1;
  const squareSize = 60;
  //com.
  for (
    let index = -Math.floor(width / (2 * squareSize));
    index < Math.ceil(width / (2 * squareSize));
    index++
  ) {
    for (
      let index2 = -Math.floor(height / (2 * squareSize));
      index2 < Math.ceil(height / (2 * squareSize));
      index2++
    ) {
      planes.push(
        <PlaneSquare
          key={1001 + counter}
          position={vec3(index * squareSize, -0.7, index2 * 60)}
          setHoveredCoordinate={setHoveredCoordinate}
        />
      );
      counter++;
    }
  }
  return planes;
};

export const vec3 = (x: number, z: number, y: number): Vector3 => {
  return new Vector3(x, z, y);
};

export const vec2 = (x: number, y: number): Vector2 => {
  return new Vector2(x, y);
};

export const rot3 = (x: number, z: number, y: number): Euler => {
  return new Euler(x, z, y);
};
