import { Object, RobotData, SensorData } from "../models/Data";

export const printRobotData = (robot: RobotData) => {
  console.log("----- ROBOT DATA -----");
  console.log(`Battery: ${robot.battery}`);
  console.log(
    `Position (rotation,x,y): (${robot.pos.r},${robot.pos.x},${robot.pos.y})`
  );
  console.log(`Storage (${robot.storage.length} item(s)):`);
  robot.storage.map((object) => {
    console.log(`   -${object}`);
  });
};

export const printSensorsData = (sensors: SensorData[]) => {
  console.log("----- SENSORS DATA -----");
  sensors.map((sensor, index) => {
    console.log(`Sensor ${index}:`);
    console.log(
      `   Position (rotation,x,y): (${sensor.pos.r},${sensor.pos.x},${sensor.pos.y})`
    );
    console.log(`   Radius: ${sensor.radius}`);
    if (sensor.sensed_objs !== null) {
      console.log(
        `   Sensed objects (${sensor.sensed_objs.length} object(s)):`
      );
      sensor.sensed_objs.map((object) => {
        console.log(`       -${object.name}`);
      });
    }
  });
};
