import { SpotLight, Stars } from "@react-three/drei";

const Lights = () => {
  return (
    <group>
      <Stars
        radius={400}
        depth={50}
        count={5000}
        factor={20}
        saturation={0}
        fade
        speed={1}
      />
      <SpotLight 
        castShadow 
        penumbra={1}
        intensity={5.0}
        target-position={[0, 0, 0]}
        position={[0, -600, 0]}
        distance={1000}
        angle={1}
        attenuation={5}
        anglePower={5}
      />
      {/*intensity changes the intensity of the shadows everywhere on the map */}
      <ambientLight position={[0, 0, 0]} intensity={0.2} />
    </group>
  );
};

export default Lights;
