import { useLoader } from "@react-three/fiber";
import { DoubleSide, TextureLoader } from "three";
import space1 from "../textures/skybox/1.jpg";
import space2 from "../textures/skybox/2.jpg";
import space3 from "../textures/skybox/3.jpg";
import space4 from "../textures/skybox/4.jpg";
import space5 from "../textures/skybox/5.jpg";
import space6 from "../textures/skybox/6.jpg";

const SkyBox = () => {
  // The CubeTextureLoader load method takes an array of urls representing all 6 sides of the cube.
  const texture1 = useLoader(TextureLoader, space1);
  const texture2 = useLoader(TextureLoader, space2);
  const texture3 = useLoader(TextureLoader, space3);
  const texture4 = useLoader(TextureLoader, space4);
  const texture5 = useLoader(TextureLoader, space5);
  const texture6 = useLoader(TextureLoader, space6);
  // Set the scene background property to the resulting texture.
  return (
    <mesh>
      <boxGeometry args={[1000, 1000, 1000]} />
      <meshBasicMaterial attach="material-0" map={texture1} side={DoubleSide} />
      {/*right*/}
      <meshBasicMaterial attach="material-1" map={texture2} side={DoubleSide} />
      {/*left*/}
      <meshBasicMaterial attach="material-2" map={texture3} side={DoubleSide} />
      {/*top*/}
      <meshBasicMaterial attach="material-3" map={texture4} side={DoubleSide} />
      {/*bottom*/}
      <meshBasicMaterial attach="material-4" map={texture5} side={DoubleSide} />
      {/*front*/}
      <meshBasicMaterial attach="material-5" map={texture6} side={DoubleSide} />
      {/*back*/}
    </mesh>
    //scene.background = texture;
  );
};

export default SkyBox;
