import React from "react";
import { useRef, useState } from "react";
import { useContext } from "react";
import { Canvas, useFrame } from "@react-three/fiber";

interface Props {
  rot: number;
  x: number;
  y: number;
}
function MyRotatingBox({ rot, x, y }: Props) {
  // This reference gives us direct access to the THREE.Mesh object
  const ref = useRef<Props>({ rot: 0, x: 0, y: 0 });
  // Hold state for hovered and clicked events
  const [hovered, hover] = useState(false);
  const [clicked, click] = useState(false);
  let timer: number;
  // Subscribe this component to the render-loop, rotate the mesh every frame

  //useFrame((state, delta) => (ref.current.rotation.x +=0.01));
  //useFrame((state, delta) => (ref.current.rotation.z +=0.01));
  useFrame((state, delta) => (ref.current.rotation.y += 0.01));
  /*
  useFrame((state, delta) => {
    
    ref.current.position.z = Math.sin(ref.current.position.z + 0.01)*3
    ref.current.position.x = Math.cos(ref.current.position.x + 0.01)*3
    if(ref.current.position.z>=3.14*7)

        ref.current.position.z =0
        ref.current.position.x =0


});
*/
  //useFrame((state, delta) => (ref.current.rotation.x += 0.01));
  //useFrame((state, delta) => (ref.current.x += 0.01));
  // Return the view, these are regular Threejs elements expressed in JSX
  return (
    <mesh
      position={[x, 2, y]}
      //position={[          Math.cos(ref.current.x)*6,         0,          Math.sin(ref.current.x)*6      ]}
      ref={ref}
      scale={clicked ? 1.5 : 1}
      onClick={(event) => click(!clicked)}
      onPointerOver={(event) => hover(true)}
      onPointerOut={(event) => hover(false)}
    >
      <boxGeometry args={[1, 1, 1]} />

      <meshStandardMaterial color={hovered ? "hotpink" : "orange"} />
    </mesh>
  );
}
export default MyRotatingBox;
