import { forwardRef } from "react";
import RobotObject from "./robot/Robot";
import LidarObjects from "./LidarObjects";
import SensorObjects from "./SensorObjects";
import CurrentPath from "./plane/CurrentPath";
import RobotPath from "./plane/RobotPath";

interface Props {
  replay: boolean;
}

const Objects = forwardRef(({ replay }: Props, ref: any) => {
  //com

  return (
    <group key={0}>
      <RobotObject ref={ref} />
      <LidarObjects replay={replay} ref={ref} />
      <SensorObjects replay={replay} ref={ref} />
      <CurrentPath ref={ref} />
      <RobotPath ref={ref} />
    </group>
  );
});

export default Objects;
