import { useRef } from "react";
import { Vector3 } from "three";
import { forwardRef, useState } from "react";
import { DoubleSide } from "three";
import { useFrame } from "@react-three/fiber";
import { vec3, vec2, rot3 } from "../../../../functions/Map";
import { MleElement } from "../../../../models/Data";
import Box from "../../legacy/Box";
import { Html } from "@react-three/drei";
import Title from "antd/es/typography/Title";
import MleBox from "./components/MleBox";
import moment from "moment";
interface Props {
  position: Vector3;
}

const ProbabilityPlane = forwardRef((props, ref: any) => {
  //Array of objects to be mapped to the canvas
  const [mleOnCanvas, setMleOnCanvas] = useState<any[]>([]);

  const prevTime = useRef<number>(moment().unix());
  useFrame(() => {
    if (!ref) return;
    if (moment().unix() - prevTime.current < 0.5) return;
    prevTime.current = moment().unix();

    //com.
    if (mleOnCanvas.length === ref.current.situationReport.mleElements.length)
      return;
    const tempMlePlanes = [];
    for (let i = 0; i < ref.current.situationReport.mleElements.length; i++) {
      const element = ref.current.situationReport.mleElements[i] as MleElement;

      tempMlePlanes.push(
        <MleBox
          key={7100 + i}
          element={element}
          gridWidth={ref.current.situationReport.gridWidth}
          gridHeight={ref.current.situationReport.gridHeight}
        />
      );
    }

    //com.
    setMleOnCanvas(tempMlePlanes);
  });

  return <group>{mleOnCanvas.map((plane) => plane)}</group>;
});

export default ProbabilityPlane;
