import { vec3 } from "../../../../functions/Map";
import { forwardRef, useRef, useState } from "react";
import { useFrame } from "@react-three/fiber";
import { rot3 } from "../../../../functions/Map";
import { group } from "console";

interface arm {
  rot: number;
  reff: any;
}

export const Arm1 = ({ rot, reff }: arm) => {
  //const ref2 = useRef<Props>({ rot: 0, x: 0, y: 0 });

  const [angle, setangle] = useState<number>(0);
  const [pos, setpos] = useState<any>([1, 0.5, 1]);
  const updateangle = useRef(angle);
  const updatepos = useRef(angle);

  useFrame(() => {
    if (reff === null || !reff || reff.current === null) return;
    //setangle(reff.current.arm1)
    updateangle.current = reff.current.arm1;
    setangle(updateangle.current);

    updatepos.current = reff.current.arm1pos;
    setpos(updatepos.current);
  });
  // useFrame((state, delta) => (ref2.current.rotation.y += 0.01));
  // console.log(angle );
  if (reff === null || !reff || reff.current === null) return <mesh></mesh>;
  return (
    <mesh
      position={pos}
      rotation={[0, angle, 0]}
      //<planeGeometry key={4002} args={[4000, 600, 1, 1]} />
    >
      <boxGeometry args={[0.2, 0.2, reff.current.arm_length]} />
      <meshBasicMaterial color={"black"} />
    </mesh>
  );
};

export const Arm2 = ({ rot, reff }: arm) => {
  //const ref2 = useRef<Props>({ rot: 0, x: 0, y: 0 });

  const [angle, setangle] = useState<number>(0);
  const [pos, setpos] = useState<any>([1, 0.5, 1]);
  const updateangle = useRef(angle);
  const updatepos = useRef(pos);

  useFrame(() => {
    if (reff === null || !reff || reff.current === null) return;

    //setangle(reff.current.arm1)
    updateangle.current = reff.current.arm2;
    setangle(updateangle.current);

    updatepos.current = reff.current.arm2pos;
    setpos(updatepos.current);
  });
  // useFrame((state, delta) => (ref2.current.rotation.y += 0.01));
  //console.log(angle );
  if (reff === null || !reff || reff.current === null) return <mesh></mesh>;

  return (
    <mesh position={pos} rotation={[0, angle, 0]}>
      <boxGeometry args={[0.2, 0.2, reff.current.arm_length]} />
      <meshBasicMaterial color={"black"} />
    </mesh>
  );
};

export const Arm3 = ({ rot, reff }: arm) => {
  //const ref2 = useRef<Props>({ rot: 0, x: 0, y: 0 });

  const [angle, setangle] = useState<number>(0);
  const [pos, setpos] = useState<any>([1, 0.5, 1]);
  const updateangle = useRef(angle);
  const updatepos = useRef(pos);

  useFrame(() => {
    if (reff === null || !reff || reff.current === null) return;
    //setangle(reff.current.arm1)
    updateangle.current = reff.current.arm3;
    setangle(updateangle.current);

    updatepos.current = reff.current.arm3pos;
    setpos(updatepos.current);
  });
  // useFrame((state, delta) => (ref2.current.rotation.y += 0.01));
  //console.log(angle );
  if (reff === null || !reff || reff.current === null) return <mesh></mesh>;
  return (
    <mesh position={pos} rotation={[0, angle, 0]}>
      <boxGeometry args={[0.2, 0.2, reff.current.arm_length]} />
      <meshBasicMaterial color={"black"} />
    </mesh>
  );
};

export const Claw1 = ({ rot, reff }: arm) => {
  //const ref2 = useRef<Props>({ rot: 0, x: 0, y: 0 });
  const [angle, setangle] = useState<number>(0);
  const [pos, setpos] = useState<any>([1, 0.5, 1]);
  const updateangle = useRef(angle);
  const updatepos = useRef(pos);

  useFrame(() => {
    if (reff === null || !reff || reff.current === null) return;
    updateangle.current = reff.current.claw1;
    setangle(updateangle.current);
    updatepos.current = reff.current.arm4pos;
    setpos(updatepos.current);
  });
  // useFrame((state, delta) => (ref2.current.rotation.y += 0.01));
  //console.log(angle );
  if (reff === null || !reff || reff.current === null) return <mesh></mesh>;
  return (
    <mesh position={pos} rotation={[0, angle, 0]}>
      <boxGeometry args={[0.2, 0.2, reff.current.claw_length]} />
      <meshBasicMaterial color={"black"} />
    </mesh>
  );
};

export const Claw2 = ({ rot, reff }: arm) => {
  //const ref2 = useRef<Props>({ rot: 0, x: 0, y: 0 });
  const [angle, setangle] = useState<number>(0);
  const [pos, setpos] = useState<any>([1, 0.5, 1]);
  const updateangle = useRef(angle);
  const updatepos = useRef(pos);

  useFrame(() => {
    if (reff === null || !reff || reff.current === null) return;
    updateangle.current = reff.current.claw2;
    setangle(updateangle.current);
    updatepos.current = reff.current.arm5pos;
    setpos(updatepos.current);
  });
  // useFrame((state, delta) => (ref2.current.rotation.y += 0.01));
  //console.log(angle );
  if (reff === null || !reff || reff.current === null) return <mesh></mesh>;
  return (
    <mesh position={pos} rotation={[0, angle, 0]}>
      <boxGeometry args={[0.2, 0.2, reff.current.claw_length]} />
      <meshBasicMaterial color={"black"} />
    </mesh>
  );
};

export const Claw_lock = ({ rot, reff }: arm) => {
  //const ref2 = useRef<Props>({ rot: 0, x: 0, y: 0 });
  const [angle, setangle] = useState<number>(0);
  const [pos, setpos] = useState<any>([1, 0.5, 1]);
  const [Arm_lock, setArm_lock] = useState<boolean>(false);
  const updateangle = useRef(angle);
  const updatepos = useRef(pos);
  const updateArm_lock = useRef(Arm_lock);
  useFrame(() => {
    if (reff === null || !reff || reff.current === null) return;
    updateangle.current = reff.current.claw_lock;
    setangle(updateangle.current);
    updatepos.current = reff.current.claw_lock_pos;
    setpos(updatepos.current);

    updateArm_lock.current = reff.current.claw_lock_bool;
    setArm_lock(updateArm_lock.current);
  });
  // useFrame((state, delta) => (ref2.current.rotation.y += 0.01));
  //setArm_lock(true);

  if (reff === null || !reff || reff.current === null) return <mesh></mesh>;
  return (
    <mesh
      position={pos}
      rotation={[0, angle, 0]}
      visible={reff.current.arm_opened}
    >
      <boxGeometry args={[0.1, 0.2, reff.current.claw_length + 0.8]} />
      <meshBasicMaterial color={"black"} visible={!Arm_lock ? true : false} />
    </mesh>
  );
};
