import { useGLTF } from "@react-three/drei";
import { Euler, Vector3 } from "three";

interface Props {
  position: Vector3;
  rotation: Euler;
  replay: boolean;
}

const Alien = ({ position, rotation, replay }: Props) => {
  const { nodes, materials } = useGLTF("/Astronaut.glb");
  const mesh0 = nodes["node-0"] as any;

  return (
    <mesh
      geometry={mesh0.geometry}
      material={materials.Astronaut_mat}
      scale={2.5}
      position={position}
      rotation={rotation}
    />
  );
};

useGLTF.preload("/Astronaut.glb");

export default Alien;
