import { DoubleSide, Vector3 } from "three";
import { rot3 } from "../../../../functions/Map";

interface CircleProps {
  position: Vector3;
  radius: number;
  color: string;
}

export const CirclePlane = ({ position, radius, color }: CircleProps) => {
  return (
    <mesh position={position} rotation={rot3(Math.PI / 2, 0, 0)}>
      <circleGeometry args={[radius, 30]} />
      <meshStandardMaterial
        color={color}
        transparent={true}
        opacity={0.5}
        side={DoubleSide}
        depthWrite={false}
        depthTest={true}
      />
    </mesh>
  );
};
