import { Progress, Space } from "antd";
import { red, green } from "@ant-design/colors";
import { useContext, useEffect, useState, forwardRef } from "react";
import RobotContext from "../../../../state/Robot";
import {
  GiBattery100,
  GiBattery75,
  GiBattery50,
  GiBattery25,
} from "react-icons/gi";

//get battery percentage from payload send by simulator
const Battery = forwardRef((props, ref: any) => {
  const [battery, setBattery] = useState<number>(100);
  //timer, get new info every second if changed
  useEffect(() => {
    const interval = setInterval(() => {
      if (!ref.current) return;
      setBattery(ref.current.robot.battery);
    }, 1000);

    return () => clearInterval(interval);
  }, [ref]);

  return (
    <div
      style={{
        height: 50,
        width: 70,
        background: "rgba(0,0,0,0.6)",
        borderRadius: 15,
      }}
    >
      <div style={{ top: 30 }}>
        <div
          style={{
            position: "absolute",
            display: "flex",
            justifyContent: "center",
            alignItems: "center",
            textAlign: "center",
            zIndex: 3,
            width: "100%",
            height: "100%",
            color: "white",
            fontSize: 14,
          }}
        >
          {battery.toFixed(0)}
        </div>
        <div
          style={{
            position: "absolute",
            display: "flex",
            justifyContent: "center",
            alignItems: "center",
            textAlign: "center",
            height: "100%",
            width: "100%",
            left: 2,
            transform: "rotate(90deg)",
            fontSize: 45,
          }}
        >
          {/* Different icon for each percentage threshold */}
          {battery <= 25 ? (
            <GiBattery25
              style={{
                color: "red",
              }}
            />
          ) : battery <= 50 ? (
            <GiBattery50
              style={{
                color: "green",
              }}
            />
          ) : battery <= 75 ? (
            <GiBattery75
              style={{
                color: "green",
              }}
            />
          ) : (
            <GiBattery100
              style={{
                color: "green",
              }}
            />
          )}
        </div>
      </div>
    </div>
  );
});

export default Battery;
