import { useEffect, useState } from "react";
import moment from "moment";
import Title from "antd/es/typography/Title";

const ClockBar = () => {
  const [currentTime, setCurrentTime] = useState<string>(
    moment().format("YYYY-MM-DD HH:mm:ss").toString()
  );
  //timer, set new time every second if changed
  useEffect(() => {
    setInterval(
      () => setCurrentTime(moment().utc().format("HH:mm:ss").toString()),
      1000
    );
  }, [currentTime]);

  return (
    <div
      style={{
        display: "flex",
        justifyContent: "center",
        alignItems: "center",
      }}
    >
      <Title level={3} style={{ color: "white", margin: 0 }}>
        {`UTC ${currentTime}`}
      </Title>
    </div>
  );
};

export default ClockBar;
