import { Space, Typography, Button } from "antd";
import Title from "antd/es/typography/Title";
import { useContext } from "react";
import LayoutContext from "../../../../state/Map";
import { useNavigate } from "react-router-dom";

const ExitWindow = () => {
  const navigate = useNavigate();
  const { setMenuModalIsOpen } = useContext(LayoutContext);
  return (
    <div
      style={{
        display: "flex",
        flexDirection: "column",
        justifyContent: "space-between",
      }}
    >
      <div
        style={{
          width: 500,
          height: 40,
          background: "rgba(0,0,0,0.9)",
        }}
      >
        <Title level={2} style={{ margin: 10 }}>
          Exit
        </Title>
      </div>
      <div
        style={{
          width: 500,
          height: 130,
          background: "rgba(1 ,1,1,0.9)",
          display: "flex",
          justifyContent: "center",
          alignItems: "center",
        }}
      >
        <Space
          direction="vertical"
          style={{
            display: "flex",
            justifyContent: "center",
            alignItems: "center",
          }}
        >
          <Typography.Text style={{ fontSize: 24 }}>
            Do you want to exit to the dashboard?
          </Typography.Text>
          <Space>
            <Button
              size="large"
              onClick={() => {
                setMenuModalIsOpen(false);
                navigate("/");
              }}
            >
              YES
            </Button>
            <Button size="large" onClick={() => setMenuModalIsOpen(false)}>
              NO
            </Button>
          </Space>
        </Space>
      </div>
    </div>
  );
};

export default ExitWindow;
