import RobotContext from "../../../../state/Robot";
import { useContext } from "react";

import { Progress, Space } from "antd";

const SpeedBar = () => {
  const { speed, setSpeed } = useContext(RobotContext);
  const { Lpower, setLpower } = useContext(RobotContext);
  const { Rpower, setRpower } = useContext(RobotContext);

  return (
    <div
      style={{
        display: "flex",
        alignItems: "center",
        flexDirection: "column",
        justifyContent: "space-between",
        borderRadius: 50,
        background: "rgba(0, 0, 0, 0)",
        userSelect: "none",
      }}
    >
      <Space wrap direction="horizontal">
        <Space direction="vertical">
          <Progress
            width={120}
            type="circle"
            percent={100}
            showInfo={false}
            status="normal"
            trailColor={`rgba(0,0,255,${Lpower / 100})`}
            strokeColor={`rgba(0,0,255,${Lpower / 100})`}
            gapDegree={260}
            gapPosition="right"
            style={{
              color: "white",
              position: "absolute",
              right: 30,
              top: 20,
            }}
          />
        </Space>
        <Space direction="vertical">
          <Progress
            width={160}
            type="dashboard"
            percent={speed}
            format={() => `${speed} m/s`}
            status="normal"
            strokeColor="red"
            trailColor={`rgba(0,0,0,0)`}
          />
        </Space>
        <Space direction="vertical">
          <Progress
            width={120}
            type="circle"
            percent={100}
            showInfo={false}
            status="normal"
            trailColor={`rgba(0,0,255,${Rpower / 100})`}
            strokeColor={`rgba(0,0,255,${Rpower / 100})`}
            gapDegree={260}
            gapPosition="left"
            strokeLinecap="round"
            style={{
              position: "absolute",
              left: 30,
              top: 20,
            }}
          />
        </Space>
      </Space>
    </div>
  );
};
export default SpeedBar;
