import { Progress, Space } from "antd";
import { red, green } from "@ant-design/colors";
import { useContext, useEffect, useState } from "react";
import RobotContext from "../../../../state/Robot";
import { GiBattery25 } from "react-icons/gi";

const Battery = () => {
  const { battery } = useContext(RobotContext);
  const [color, setColor] = useState(green[6]);

  useEffect(() => {
    if (battery < 30) {
      setColor(red[5]);
    } else {
      setColor(green[5]);
    }
  }, [battery]);

  return (
    <>
      <Space direction="vertical">
        <div style={{ background: "rgba(0,0,0,0.6)" }}>
          <div
            style={{
              position: "absolute",
              top: 17,
              left: 8,
              zIndex: 3,
              color: "white",
              fontSize: 12,
            }}
          >
            100%
          </div>
          <GiBattery25
            style={{ color: "green", fontSize: 50, transform: "rotate(90deg)" }}
          />
        </div>

        <div id="battery-inside">
          <Progress
            status={"active"}
            style={{
              border: "2px solid white",
              borderRadius: "5px",
              float: "left",
              justifyContent: "center",
              padding: "2px",
              background: "rgb(0,0,0,0.6)",
            }}
            steps={10}
            showInfo={false}
            strokeColor={color}
            strokeWidth={30}
            percent={battery}
          />
          <div
            id="battery-end"
            style={{
              float: "right",
              height: "12px",
              width: "4px",
              marginTop: "12px",
              content: " ",
              alignContent: "center",
              background: "white",
            }}
          ></div>
        </div>
      </Space>
    </>
  );
};

export default Battery;
