import { Vector2, Vector3 } from "three";

export interface SensorComponent {
  id: number;
  sensorObject: JSX.Element;
  sensedObjects: JSX.Element[];
}

export interface RobotSensorComponent {
  id: number;
  sensedObjects: JSX.Element[];
}

export interface CameraState {
  position: "God" | "Sensor" | "Robot" | Vector3;
  target: "Robot" | "Sensor" | "Origo" | Vector3;
  zoom: number;
  sensorId: number;
}

export interface InterestingArea {
  position: Vector2;
}

export interface Instruction {
  id: number;
  location: Position[];
  battery: number;
  type: string;
}

export interface Position {
  object: number | "robot";
  position: Vector2 | "robot";
}
