import { Button, Image, Tooltip, Typography } from "antd";
import { HomeOutlined } from "@ant-design/icons";
import { useNavigate } from "react-router-dom";
import moment from "moment";
import { useContext } from "react";
import LayoutContext from "../../state/Map";
import logo from "../../assets/logo.png";

const ReplayNavbar = () => {
  const { darkMode } = useContext(LayoutContext);

  const navigate = useNavigate();

  return (
    <div
      style={{
        width: "100%",
        height: 60,
        display: "flex",
        flexDirection: "row",
        justifyContent: "space-around",
        alignItems: "center",
        backgroundColor: darkMode ? "#001529" : "#fff",
        padding: "0px 20px 0px 20px",
      }}
    >
      <div
        style={{
          width: "50%",
          display: "flex",
          justifyContent: "flex-start",
          alignItems: "center",
        }}
      >
        <Image
          height={50}
          src={logo}
          preview={false}
          onClick={() => navigate("/dashboard")}
        />
        <div
          style={{
            display: "flex",
            justifyContent: "center",
            alignItems: "flex-start",
            flexDirection: "column",
            marginLeft: 25,
          }}
        >
          <Typography.Text style={{ color: darkMode ? "#fff" : "#000" }}>
            {`Total frames: 1`}
          </Typography.Text>
          <Typography.Text style={{ color: darkMode ? "#fff" : "#000" }}>
            {`Latest update: ${moment().format("HH:mm:ss DD/MM/YYYY")}`}
          </Typography.Text>
        </div>
      </div>
      <div
        style={{
          width: "50%",
          display: "flex",
          justifyContent: "flex-end",
          alignItems: "center",
        }}
      >
        <Button
          size="large"
          type="primary"
          shape="circle"
          onClick={() => navigate("/home")}
        >
          <Tooltip title="Home">
            <HomeOutlined />
          </Tooltip>
        </Button>
      </div>
    </div>
  );
};

export default ReplayNavbar;
