import React, { useContext, useEffect, useMemo, useState } from "react";

interface State {
  toggleActionLogTable: boolean;
  toggleBattery: boolean;
  toggleInventory: boolean;
  toggleSpeed: boolean;
  toggleClock: boolean;
  togglePath: boolean;
  togglePathhistory: boolean;
  settoggleActionLogTable: (b: boolean) => void;
  settoggleBattery: (b: boolean) => void;
  settoggleInventory: (b: boolean) => void;
  settoggleSpeed: (b: boolean) => void;
  settoggleClock: (b: boolean) => void;
  settogglePath: (b: boolean) => void;
  settogglePathhistory: (b: boolean) => void;
}

const initialState: State = {
  toggleActionLogTable: false,
  toggleBattery: false,
  toggleInventory: false,
  toggleSpeed: true,
  toggleClock: true,
  togglePath: true,
  togglePathhistory: true,
  settoggleActionLogTable: () => {},
  settoggleBattery: () => {},
  settoggleInventory: () => {},
  settoggleSpeed: () => {},
  settoggleClock: () => {},
  settogglePath: () => {},
  settogglePathhistory: () => {},
};

const FullScreenOverlayComponenetsContext =
  React.createContext<State>(initialState);

interface Props {
  children: React.ReactNode;
}

export const OverlayContextProvider = ({ children }: Props) => {
  const [toggleActionLogTable, settoggleActionLogTable] = useState<boolean>(
    initialState.toggleActionLogTable
  );
  const [toggleBattery, settoggleBattery] = useState<boolean>(
    initialState.toggleBattery
  );
  const [toggleInventory, settoggleInventory] = useState<boolean>(
    initialState.toggleInventory
  );
  const [toggleSpeed, settoggleSpeed] = useState<boolean>(
    initialState.toggleSpeed
  );
  const [toggleClock, settoggleClock] = useState<boolean>(
    initialState.toggleClock
  );

  const [togglePath, settogglePath] = useState<boolean>(
    initialState.togglePath
  );

  const [togglePathhistory, settogglePathhistory] = useState<boolean>(
    initialState.togglePathhistory
  );

  const value: State = useMemo(() => {
    return {
      toggleActionLogTable,
      toggleBattery,
      toggleClock,
      toggleInventory,
      toggleSpeed,
      togglePath,
      togglePathhistory,
      settoggleActionLogTable,
      settoggleBattery,
      settoggleClock,
      settoggleInventory,
      settoggleSpeed,
      settogglePath,
      settogglePathhistory,
    };
  }, [
    toggleActionLogTable,
    toggleBattery,
    toggleClock,
    toggleInventory,
    toggleSpeed,
    togglePath,
    togglePathhistory,
  ]);

  return (
    <FullScreenOverlayComponenetsContext.Provider value={value}>
      {children}
    </FullScreenOverlayComponenetsContext.Provider>
  );
};

export default FullScreenOverlayComponenetsContext;
