import { Item } from "../models/Inventory";
import React, { useMemo, useState } from "react";
import { ItemList } from "../data/Items";

interface State {
  inventoryContents: Item[];
  addToInventoryContents: (v: number) => void;
  removeFromInventoryContents: (v: number) => void;
}

const initialState: State = {
  inventoryContents: [],
  addToInventoryContents: () => {},
  removeFromInventoryContents: () => {},
};

const InventoryContext = React.createContext<State>(initialState);

interface Props {
  children: React.ReactNode;
}

export const InventoryContextProvider = ({ children }: Props) => {
  const [inventoryContents, setInventoryContents] = useState<Item[]>(
    initialState.inventoryContents
  );

  const value: State = useMemo(() => {
    return {
      inventoryContents,
      addToInventoryContents: (v: number) => {
        if (inventoryContents.length < 5) {
          console.log("HELOOOOOOOOO");
          console.log(inventoryContents.length);
          ItemList.forEach((item, index) => {
            if (item.id === v) {
              console.log(item.id);
              setInventoryContents((prevState) => [...prevState, item]);
            }
          });
        } else {
          console.log("Inventory full, cannot pick up item!");
        }
      },
      removeFromInventoryContents: (v: number) => {
        let tempInventoryContents = inventoryContents;
        tempInventoryContents = tempInventoryContents.filter(
          (item, index) => index !== v - 1
        );
        setInventoryContents(tempInventoryContents);
      },
    };
  }, [inventoryContents]);
  return (
    <InventoryContext.Provider value={value}>
      {children}
    </InventoryContext.Provider>
  );
};

export default InventoryContext;
